/*
**  WASABI-Hot! version 1.2b    (DeviceController sub-unit)
**
**
**      -- copyright (c) 2001-2003 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 08-Dec-2003                                             **
**
**
**
**     HIGASHIYAMA, Ken 
**      
**		Application Laboratory, Portable Systems
**      Semiconductors Div, Philips Japan Ltd.
**      ken.higashiyama@philips.com
**      +81-3-3740-5136 
**
**
*/

#include <stdio.h>
#include <dos.h>
#include <conio.h>

#include		"general.h"
#include		"ui.h"
#include		"beep.h"

#include "_dc/dc_main.h"
#include "_dc/dc_hal.h"
#include "_dc/dc_comm.h"
#include "_dc/dc_isr.h"
#include "_dc/dc_flags.h"
#include "_dc/dc_chap9.h"
#include "_dc/dc_spcfc.h"

#include "_otg/otg_demo.h"


struct {
		unsigned char xfer_direction;
		unsigned char type;
		unsigned char recipient;
	} bmRequestType;

unsigned char bRequest;
unsigned short wValue, wIndex, wLength;
unsigned short dc_config_value, dc_alt_setting_value;

STRING_DESCRIPTOR		*string_dscrptr_manufacturer_ptr;
STRING_DESCRIPTOR		*string_dscrptr_product_ptr;
STRING_DESCRIPTOR		*string_dscrptr_serialnumber_ptr;


void ( *Standard_request[] )();
void ( *Class_request[] )();
void ( *Vendor_request[] )();

void Get_Status();
void Clear_Feature();
void Reserved();
void Set_Feature();
void Set_Address();
void Get_Descriptor();
void Set_Descriptor();
void Get_Configuration();
void Set_Configuration();
void Get_Interface();
void Set_Interface();
void Synch_Frame();

//void Vendor_request3( void );

unsigned long test=0;

unsigned short	wCount;
unsigned short	*pControlData;

void dc_control_handler()
{
	int	i;


	if ( ctrl.setup )
	{
		hwacces_isr_hw_disable();
		disable();

		bmRequestType.xfer_direction= (unsigned char)((setup_buf[0] & XFER_DIRECTION) >>7);
		bmRequestType.type= (unsigned char)((setup_buf[0] & TYPE) >>5);
		bmRequestType.recipient= (unsigned char)(setup_buf[0] & RECIPIENT);
		bRequest= (unsigned char)(setup_buf[0]>>8);
		wValue= setup_buf[1];
		wIndex= setup_buf[2];
		wLength= setup_buf[3];

		wCount=0;

	//			for ( i=0; i<3; Dc_printf( WHITE, CONTINUE, "%04X ", change_endian( setup_buf[i++] ) ) );
	//			Dc_printf( WHITE, CONTINUE, "\r\n" );


		if ( bmRequestType.type == 3 || bmRequestType.recipient >= 4 )	// Is received class Type or Recipient "Reserved"?
		{	
			ctrl.setup=0;
			Stall_handshake();
			return;
		}


		if ( bmRequestType.xfer_direction )	// Device to Host
			ctrl.read=1;
		else
			if ( wLength )		// Setup followed by Data?
				ctrl.write=1;

		if ( bmRequestType.type == 0 )	// standard request
			( *Standard_request[ bRequest ] )();
		if ( bmRequestType.type == 1 )	// class request
			( *Class_request[ bRequest ] )();
		if ( bmRequestType.type == 2 )	//  vendor request
			( *Vendor_request[ bRequest ] )();
			
		ctrl.setup=0;

		enable();
		hwacces_isr_hw_enable();
	}

	if ( vendor_specific.wait )
	{
		hwacces_isr_hw_disable();
		disable();

		if ( vendor_specific.data )
		{
			io_req_data_stage();
		}
		enable();
		hwacces_isr_hw_enable();
	}

}			


void ( *Standard_request[] )()
={
Get_Status,
Clear_Feature,
Reserved,
Set_Feature,
Reserved,
Set_Address,
Get_Descriptor,
Set_Descriptor,
Get_Configuration,
Set_Configuration,
Get_Interface,
Set_Interface,
Synch_Frame
};

void ( *Class_request[] )()
={
Reserved
};

void ( *Vendor_request[] )()
={
Reserved,
Reserved,
Reserved,
			Vendor_request3,
Reserved,
Reserved,
Reserved,
Reserved,
Reserved,
Reserved,
Reserved,
Reserved,
			io_request,
Reserved,
Reserved,
Reserved
};


/*
char			g_s[ 64 ];
unsigned short	g_length;


void Vendor_request3( void )
{
	if ( ( wValue >> 8 ) == OTG_DEMO_GET_A_STRING )			// Get Hello ?
	{
		OTG_demo_peripheral_side_7( g_s, &g_length, wValue & 0xF );
		start_transmit( (unsigned short *)g_s, g_length  );
		Dc_printf( WHITE, CONTINUE, "Hello message returned.  by request from remote\r\n" );
	}
	
	
	else if ( ( wValue >> 8 ) == OTG_DEMO_CTRL_AUDIO )	//	Get list item ?
	{
		unsigned char	start	= 0;
	
		start	= OTG_demo_peripheral_side_9_0( g_s, &g_length, wValue );

		start_transmit( (unsigned short *)g_s, g_length  );

		if ( start )
			OTG_demo_peripheral_side_9_11( wValue );
	}
	
	
	else if ( ( wValue >> 8 ) == OTG_DEMO_CLOCK_SYNC )		//	Clock sync
	{
		OTG_demo_peripheral_side_1( g_s, &g_length );
		start_transmit( (unsigned short *)g_s, g_length  );
		Dc_printf( WHITE, CONTINUE, "Sending time info 0x%08lX  0x%08lX l=%u\r\n", *((unsigned long *)g_s), *((unsigned long *)(g_s + 4)), g_length );
	}
	
	
	else if ( ( wValue >> 8 ) == OTG_DEMO_BAR_DISPLAY )	//	Dummy data transfer ?
	{
		OTG_demo_peripheral_side_8( wValue & 0xFF );
		
		start_transmit( (unsigned short *)g_s, 64  );
		Dc_printf( WHITE, CONTINUE, "Dummy data transfer (%02d - %d)\r", wValue & 0x7F, wValue >> 7 );
		
		if ( (wValue & 0xFF) == 69 )
			Dc_printf( WHITE, CONTINUE, "\r\n" );
	}
	
	
	else if ( ( wValue >> 8 ) == OTG_DEMO_APP_UPDATE )	//	Dummy data transfer ?
	{
		OTG_demo_peripheral_side_0( g_s, &g_length, wValue & 0xFF );

		start_transmit( (unsigned short *)g_s, g_length  );
		Dc_printf( WHITE, CONTINUE, "file data transfer %d\r", wValue & 0xFF );
	}
	
	
	else if ( ( wValue >> 8 ) == OTG_DEMO_REMOTE_AUDIO )	//	data transfer through EP1?
	{
		OTG_demo_peripheral_side_2( g_s, &g_length, wValue & 0xFF );

		if ( ctrl.read==1 )
			start_transmit( (unsigned short *)g_s, g_length  );
		else
		{
			vendor_specific.data = 0;
			vendor_specific.wait = 0;

			zero_packet();
		}	
		Dc_printf( WHITE, CONTINUE, "remote command : 0x%02X\r\n", wValue & 0xFF );
	}

	else if ( ( wValue >> 8 ) == OTG_DEMO_REMOTE_BEEP )			// Get Hello ?
	{
		OTG_demo_peripheral_side_3( g_s, &g_length, wValue & 0xF );
		start_transmit( (unsigned short *)g_s, g_length  );
		Dc_printf( WHITE, CONTINUE, "Hello message returned.  by request from remote\r\n" );
	}
	

	else								// Unsupported Descriptor?
	{
		Stall_handshake();
		ctrl.read=0;
	}
	
}
*/

/*			Standard Request			*/
void Get_Status()
{
	unsigned short	status;
	
	if ( bmRequestType.recipient == 0 )			// Device
	{
		status = 0x0003;	// remote-wakeup, self-powered
		start_transmit( &status, 2 );
	}
	if ( bmRequestType.recipient == 1 )			// Interface
	{
		status = 0x0000;
		start_transmit( &status, 2 );
	}
	if ( bmRequestType.recipient == 2 )			// Endpoint
	{
		status = Comm_r16( Chk_Ep_Status + ( (unsigned char)wIndex & 0x00F) ) & 0x0080;
		status >>= 7;
		start_transmit( &status, 2 );
	}
}		 
		
void Clear_Feature()
{
	if ( bmRequestType.recipient == 0 )			// Device
	{
		if ( wValue == DEVICE_REMOTE_WAKEUP )
		{
			//???????
			zero_packet();
			//Stall_handshake();
		}	
		else Stall_handshake();
	}
	if ( bmRequestType.recipient == 1 )			// Interface
	{
		Stall_handshake();
	}
	if ( bmRequestType.recipient == 2 )			// Endpoint
	{
		if ( wValue == ENDPOINT_STALL )
		{
			Comm(Unstall_Ep + ( (unsigned char)wIndex & 0x7F ) );	// endpoint stall
			zero_packet();		// end of status stage
		}
		else	Stall_handshake();
	}


}

void Reserved()
{
	Stall_handshake();
}

void Set_Feature()
{
	Dc_printf( WHITE, CONTINUE, "Set_Feature()\r\n" );

	if ( bmRequestType.recipient == 0 )			// Device
	{
		if ( wValue == DEVICE_REMOTE_WAKEUP )
		{
			//???????
			zero_packet();
			//Stall_handshake();
		}

		else if ( wValue == 3 )
		{
			OTG_host_enable_command_from_A_device( wValue );
			zero_packet();
		}

		else if ( wValue == 4 )
		{
			OTG_host_enable_command_from_A_device( wValue );
			zero_packet();
		}

		else if ( wValue == 5 )
		{
			OTG_host_enable_command_from_A_device( wValue );
			zero_packet();
		}

		else Stall_handshake();
	}
	
	
	
	
	if ( bmRequestType.recipient == 1 )			// Interface
	{
		Stall_handshake();
	}
	if ( bmRequestType.recipient == 2 )			// Endpoint
	{
		if ( wValue == ENDPOINT_STALL )
		{
			Comm(Stall_Ep + ( (unsigned char)wIndex & 0x7F ) );	// endpoint stall
			zero_packet();		// end of status stage
		}
		else	Stall_handshake();
	}
}

void Set_Address()
{
	Comm_w16( W_Device_Address, ( 0x80 | (unsigned char) wValue )  );
	zero_packet();							// end of status stage
	Dc_printf( WHITE, CONTINUE, "Set Address (New Address %d)\r\n", (unsigned char) wValue );
}

void Get_Descriptor()
{
	if ( ( wValue >> 8 ) == DEVICE )			// Get Device Descriptor?
	{
		start_transmit( (unsigned short *)&device_dscrptr, (unsigned short)sizeof ( DEVICE_DESCRIPTOR )  );
		Dc_printf( WHITE, CONTINUE, "Get Descriptor (Device)\r\n" );
	}
	else if ( ( wValue >> 8 ) == CONFIGURATION )	// Get Configuration Descriptor?
	{
		start_transmit(  (unsigned short *)&configuration_dscrptr_table, (unsigned short)sizeof ( CONFIG_DESCRIPTOR_TABLE ) );
		Dc_printf( WHITE, CONTINUE, "Get Descriptor (Configuration)\r\n" );
	}
	
	else if ( ( wValue >> 8 ) == OTG )
	{
		start_transmit( (unsigned short *)&otg_dscrptr, (unsigned short)sizeof (OTG_DESCRIPTOR ) );
		Dc_printf( WHITE, CONTINUE, "Get Descriptor (On-The-Go)\r\n" );
	}

	else if ( ( wValue >> 8 ) == STRING )	// Get String Descriptor?
	{
		switch ( wValue & 0x00FF )
		{
			case 0:
				{
					start_transmit( (unsigned short *)&string_langid, (unsigned short)sizeof ( STRING_LANGID) );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 0)\r\n" );
					break;
				}
#if 0
			case 1:
				{
					start_transmit( (unsigned short *)&string_dscrptr_manufacturer, (unsigned short)sizeof ( STRING_DESCRIPTOR) );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 1)\r\n" );
					break;
				}
			case 2:
				{
					start_transmit( (unsigned short *)&string_dscrptr_product, (unsigned short)sizeof ( STRING_DESCRIPTOR) );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 2)\r\n" );
					break;
				}
			case 3:
				{
					start_transmit( (unsigned short *)&string_dscrptr_serialnumber, (unsigned short)sizeof ( STRING_DESCRIPTOR) );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 3)\r\n" );
					break;
				}
#else
			case 1:
				{
					start_transmit( (unsigned short *)string_dscrptr_manufacturer_ptr, string_dscrptr_manufacturer_ptr->bLength );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 1)\r\n" );
					break;
				}
			case 2:
				{
					start_transmit( (unsigned short *)string_dscrptr_product_ptr, string_dscrptr_product_ptr->bLength );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 2)\r\n" );
					break;
				}
			case 3:
				{
					start_transmit( (unsigned short *)string_dscrptr_serialnumber_ptr, string_dscrptr_serialnumber_ptr->bLength );
					Dc_printf( WHITE, CONTINUE, "Get Descriptor (String 3)\r\n" );
					break;
				}
#endif
			default:	
				{
					Stall_handshake();
				}
		}
	}
	else								// Unsupported Descriptor?
	{
		Stall_handshake();
		ctrl.read=0;
	}
}

void Set_Descriptor()
{
	Stall_handshake();
}

void Get_Configuration()
{
	start_transmit( &dc_config_value, 0x01 );
	Dc_printf( WHITE, CONTINUE, "Get Configuration\r\n" );
}

void Set_Configuration()
{
//	intr_1.configured=0;
	if ( wValue )
		intr_1.configured=1;
	dc_config_value=wValue;
	zero_packet();							// end of status stage

	Dc_printf( WHITE, CONTINUE, "Set Configuration (New Configuration %d)\r\n", dc_config_value );
}

void Get_Interface()
{
	start_transmit( &dc_alt_setting_value, 1 );
	Dc_printf( WHITE, CONTINUE, "Get Interface\r\n" );
}

void Set_Interface()
{
	dc_alt_setting_value=wValue;

	beep( 880.00, 1.00, DECAY, POLY );


	Comm_w16(W_Ctrl_Out_Config, FIFOEN | FFOSZ_64);
	Comm_w16(W_Ctrl_In_Config, FIFOEN | DIR_IN | FFOSZ_64);
	Comm_w16(W_Ep_Config+1, FIFODISABLE);
	Comm_w16(W_Ep_Config+2, FIFODISABLE);
	Comm_w16(W_Ep_Config+3, FIFOEN | FFOSZ_64);

#ifdef	USE_DOUBLE_BUFFER_FOR_DEV_EP4
	Comm_w16(W_Ep_Config+4, FIFOEN | DIR_IN | FFOSZ_64 | DBLBUF);
#else
	Comm_w16(W_Ep_Config+4, FIFOEN | DIR_IN | FFOSZ_64);
#endif

	Comm_w16(W_Ep_Config+5, FIFOEN | FFOISO | FFOSZ_I_512);
	Comm_w16(W_Ep_Config+6, FIFOEN | DIR_IN | FFOISO | FFOSZ_I_512);
	Comm_w16(W_Ep_Config+7, FIFODISABLE);
	Comm_w16(W_Ep_Config+8, FIFODISABLE);
	Comm_w16(W_Ep_Config+9, FIFODISABLE);
	Comm_w16(W_Ep_Config+10, FIFODISABLE);
	Comm_w16(W_Ep_Config+11, FIFODISABLE);
	Comm_w16(W_Ep_Config+12, FIFODISABLE);
	Comm_w16(W_Ep_Config+13, FIFODISABLE);
	Comm_w16(W_Ep_Config+14, FIFODISABLE);



	zero_packet();							// end of status stage

	Dc_printf( WHITE, CONTINUE, "Set Interface (Alt setting %d)\r\n", dc_alt_setting_value );
}

void Synch_Frame()
{
	zero_packet();							// end of status stage
}

void start_transmit( unsigned short *table, unsigned short len )
{
	pControlData = table;
	
	if ( wLength > len )		// if the host request data more than descriptor size
		wLength = len;		// the device should return appropriate length

	if  ( wLength > MAX_PACKET_SIZE0 )
	{
		Comm_w( W_Ctrl_In_Buf, MAX_PACKET_SIZE0, pControlData );
		wCount=MAX_PACKET_SIZE0;
	}
	else
	{
		Comm_w( W_Ctrl_In_Buf, wLength, pControlData );
		ctrl.read=0;					// end of data stage
		wCount=0;
	}
	Comm( Valid_Ctrl_In );
}

void Stall_handshake()
{
	disable();
	disable_Dc();

	Comm( Stall_Ctrl_Out );
	Comm( Stall_Ctrl_In );

	enable_Dc();
	enable();
	Dc_printf( WHITE, CONTINUE, "Endpoint0 Stalled\r\n" );
}

void zero_packet()
{
	Comm_w16( W_Ctrl_In_Buf, 0 );
	Comm( Valid_Ctrl_In );
}


DEVICE_DESCRIPTOR	 device_dscrptr
={
	sizeof ( DEVICE_DESCRIPTOR ),		// bLength: sizeo of this descriptor in bytes
	DEVICE,								// bDescriptorType: DEVICE=1
	0x0110,								// bcdUSB: USB1.1 (0110)
	0,									// bDeviceClass
	0,									// bDeviceSubClass
	0,									// bDeviceProtocol
	MAX_PACKET_SIZE0,					// bMaxPacketSize
//	0x0471,								// idVendor PHILIPS vendor ID:  0x0471
	PHILIPS_VID,						// idVendor PHILIPS vendor ID:  0x0471
//	0x0168,								// idProduct
	WASABI_PID,							// idProduct
	0x0100,								//bcdDevice
	1,									// iManufacturer
	2,									// iProduct
	3,									// iSerialNumber
	1									// bNumConfigurations
};

OTG_DESCRIPTOR			otg_dscrptr
={
	sizeof ( OTG_DESCRIPTOR ),
	OTG,
	0x03
};

CONFIG_DESCRIPTOR_TABLE	configuration_dscrptr_table
 = {
	 {
		sizeof ( CONFIGURATION_DESCRIPTOR ),
		CONFIGURATION,
		sizeof ( CONFIG_DESCRIPTOR_TABLE ),
		1,
		1,
		0,
		0xC0,
		0x32
	}, 
	 {
		sizeof ( INTERFACE_DESCRIPTOR ),
		INTERFACE,
		0,
		0,
		0,
		0,
		0,
		0,
		0
	},
	 {
		sizeof ( INTERFACE_DESCRIPTOR ),
		INTERFACE,
		0,
		1,
		4,
		0,
		0,
		0,
		0
	},
	{
		sizeof ( ENDPOINT_DESCRIPTOR ),
		ENDPOINT,
		0x03,
		0x02,
		0x0040,
		0
	},
	{
		sizeof ( ENDPOINT_DESCRIPTOR ),
		ENDPOINT,
		0x84,
		0x02,
		0x0040,
		0
	},
	{
		sizeof ( ENDPOINT_DESCRIPTOR ),
		ENDPOINT,
		0x05,
		0x01,
		0x0200,
		0x01
	},
	{
		sizeof ( ENDPOINT_DESCRIPTOR ),
		ENDPOINT,
		0x86,
		0x01,
		0x0200,
		0x01
	},
	{
		sizeof ( OTG_DESCRIPTOR ),
		OTG,
		0x03
	}
 };


STRING_LANGID			string_langid
={
	sizeof ( STRING_LANGID ),			// language ID
	STRING,
	{
		9, 4
	}	
};


#if 0
STRING_DESCRIPTOR		string_dscrptr_manufacturer
={
	sizeof ( STRING_DESCRIPTOR ),		// iManufacturer
	STRING,
	{
		'P',0,
		'h',0,
		'i',0,
		'l',0,
		'i',0,
		'p',0,
		's',0,
		' ',0,
		'S',0,
		'e',0,
		'm',0,
		'i',0,
		'c',0,
		'o',0,
		'n',0,
		'd',0,
		'u',0,
		'c',0,
		't',0,
		'o',0,
		'r',0,
		's',0,
		' ',0,
		'I',0,
		'S',0,
		'P',0,
		'1',0,
		'3',0,
		'6',0,
		'2',0
	}
};

STRING_DESCRIPTOR		string_dscrptr_product
={
	sizeof ( STRING_DESCRIPTOR ),		// iPdoruct
	STRING,
	{
		'W',0,
		'A',0,
		'S',0,
		'A',0,
		'B',0,
		'I',0,
		'-',0,
		'H',0,
		'o',0,
		't',0,
		'!',0,
		' ',0,
		' ',0,
		'O',0,
		'T',0,
		'G',0,
		'-',0,
		'D',0,
		'e',0,
		'm',0,
		'o',0
	}
};

STRING_DESCRIPTOR		string_dscrptr_serialnumber
={
	sizeof ( STRING_DESCRIPTOR ),		// iSerialNumber
	STRING,
	{
		'V',0,
		'e',0,
		'r',0,
		's',0,
		'i',0,
		'o',0,
		'n',0,
		' ',0,
		'X',0,
		'.',0,
		'X',0
	}
};

#else
#endif




#include	<string.h>
#include	<alloc.h>


STRING_DESCRIPTOR *str_to_str_descriptor( char *src )
{
	char			*trg_base;
	char 			*trg;
	unsigned char	length;
	unsigned char	i;
	

	length		= strlen( src );

	if ( NULL == (trg_base	= (char *)malloc( sizeof( char ) * ((length << 1) + 2) )) )
		mprintf( LIGHTRED, ABORT, "malloc failed @ str_to_str_descriptor" );
	
	trg		= trg_base;
	
	*trg++	= (length << 1) + 2;
	*trg++	= STRING;
	
	for ( i = 0; i < length; i++ )
	{
		*trg++	= *src++;
		*trg++	= 0;
	}
	
	return ( (STRING_DESCRIPTOR *)trg_base );
}




void string_descriptor_init( void )
{
//                                     0         1         2         3         4         5     
//									   0123456789012345678901234567890123456789012345678901234567<<
	char	manufacturer[]			= "Philips Semiconductors @Tokyo     Philips Japan, Ltd.";
	char	product[]				= "WASABI-Hot! \"On-The-Go\" demonstration program for ISP1362";
	char	serialnumber[ 64 ];
	
	sprintf( serialnumber, "version %s (build : %s - %s)", VERSION_NUMBER, __DATE__, __TIME__ );
	
	string_dscrptr_manufacturer_ptr		= str_to_str_descriptor( manufacturer );
	string_dscrptr_product_ptr			= str_to_str_descriptor( product );
	string_dscrptr_serialnumber_ptr		= str_to_str_descriptor( serialnumber );
}


void overwrite_OTG_descriptor( unsigned char value )
{
	*((((unsigned char *)(&configuration_dscrptr_table)) + ( sizeof ( CONFIG_DESCRIPTOR_TABLE ) )) - 1)		= value;
	*(((unsigned char *)(&otg_dscrptr) + 3) - 1)	= value;
}


















