/*
**  WASABI-Hot! version 1.2b   
**
**
**      -- copyright (c) 2001-2003 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 08-Dec-2003                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Portable Systems
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/

#ifndef _ISR_H
#define _ISR_H

/****************************************************************************/
/*	constants																*/
/****************************************************************************/

/*	ISR and utility routines  */

#define		HcuInterrupt_SOFISTLInt			0x0001
#define		HcuInterrupt_ISTL_0_Int			0x0002
#define		HcuInterrupt_ISTL_1_Int			0x0004
#define		HcuInterrupt_AllEOTInterrupt	0x0008
#define		HcuInterrupt_OPR_Reg			0x0010
#define		HcuInterrupt_HCSuspend			0x0020
#define		HcuInterrupt_ClkReady			0x0040
#define		HcuInterrupt_INTL_IRQ			0x0080
#define		HcuInterrupt_ATL_IRQ			0x0100
#define		HcuInterrupt_OTG_IRQ			0x0200

#define		HcInterruptStatus_SO			0x00000001
#define		HcInterruptStatus_SF			0x00000004
#define		HcInterruptStatus_RD			0x00000008
#define		HcInterruptStatus_UE			0x00000010
#define		HcInterruptStatus_FNO			0x00000020
#define		HcInterruptStatus_RHSC			0x00000040



/*
**		bit position definitions for "gp_isr_flag"	
*/

#define		SOFISTLInt			HcuInterrupt_SOFISTLInt
#define		ISTL_0_Int			HcuInterrupt_ISTL_0_Int
#define		ISTL_1_Int			HcuInterrupt_ISTL_1_Int
#define		AllEOTInterrupt		HcuInterrupt_AllEOTInterrupt
#define		OPR_Reg				HcuInterrupt_OPR_Reg
#define		HCSuspend			HcuInterrupt_HCSuspend
#define		ClkReady			HcuInterrupt_ClkReady
#define		INT_IRQ				HcuInterrupt_INTL_IRQ
#define		ATL_IRQ				HcuInterrupt_ATL_IRQ
#define		OTG_IRQ				HcuInterrupt_OTG_IRQ
#define		SO					( HcInterruptStatus_SO   << 10 )
#define		SF					( HcInterruptStatus_SF   <<  9 )
#define		RD					( HcInterruptStatus_RD   <<  9 )
#define		UE					( HcInterruptStatus_UE   <<  9 )
#define		FNO					( HcInterruptStatus_FNO  <<  9 )
#define		RHSC				( HcInterruptStatus_RHSC <<  9 )



#define		MAXMUM_NUMBER_OF_SOF_SERVICE_ROUTINE_METHOD		2
#define		SERVICE_ROUTINE_INITIALIZE						{ NULL, NULL }


/****************************************************************************/
/*	types																	*/
/****************************************************************************/

typedef			void interrupt		(* isrPtr)();
typedef			void 				(* funcPtr)();
typedef			void 				(* interrupt_service_func_ptr)( unsigned char val );


/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

extern unsigned long	gp_sof_counter;
extern unsigned short	gp_isr_flag;
extern unsigned short	gp_rhsc_event_counter;
extern unsigned short	gp_event_counter;
extern unsigned short	gp_hardware_configuration_setting;


/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

void			interrupt	isr_isr_USB_Hc( void );
unsigned short	isr_disable_Hc( void );
void			isr_enable_Hc( unsigned short intr_en );
funcPtr			isr_install_SOF_service_routine( funcPtr function_ptr );
funcPtr			isr_install_ISTL_service_routine( funcPtr function_ptr );
funcPtr			isr_install_INTL_IRQ_service_routine( funcPtr function_ptr );
funcPtr			isr_install_ATL_IRQ_service_routine( funcPtr function_ptr );
funcPtr			isr_install_OTG_IRQ_service_routine( funcPtr function_ptr );
unsigned long	isr_get_frame_number( void );


#endif