/*
**  WASABI-Hot! version 1.2b    (OTG sub-unit)
**
**
**      -- copyright (c) 2001-2003 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 08-Dec-2003                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Portable Systems
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/


/****************************************************************************/
/*	includes																*/
/****************************************************************************/

#include		<stdio.h>
#include		<stdlib.h>
#include		<dos.h>
#include		<string.h>
#include		<conio.h>
#include		<alloc.h>
#include		<fcntl.h>
#include		<share.h>
#include		<sys\stat.h>
#include		<time.h>


#include		"general.h"
#include		"ui.h"
#include		"beep.h"

#include		"_hc_core/dev_ep.h"
#include		"_hc_core/isr.h"
#include		"_hc_core/port_ctl.h"
#include		"_hc_core/atl_mix.h"

#include		"_hc_hw/hc_comm.h"
#include		"_hc_hw/hw_acces.h"

#include		"_dc/dc_flags.h"

#include 		"_otg/otg.h"
#include 		"_otg/otg_demo.h"

#include		"class_dr/audio/sing.h"
#include		"_hc_cls/cls_hndl.h"


/****************************************************************************/
/*	constants																*/
/****************************************************************************/

#define			OTG_ERROR_FAREND_GRAB_FAILD			1
#define			OTG_ERROR_NO_FAREND_DEVICE			2

#define			OTG_CONTROL_TR_OK					0
#define			OTG_CONTROL_TR_ERROR				1

#define			OTG_CONTROL_TR_DIR_OUT				0
#define			OTG_CONTROL_TR_DIR_IN				1



#define		OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER				0x80


/****************************************************************************/
/*	types																	*/
/****************************************************************************/

typedef	struct _otg_target		{	
									unsigned char		previous_bus_request_state;
									device_instance		*target_device_instance_ptr;
									char				id_name[ 11 ];
                                }
                                otg_target;


/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

otg_target		g_far_end;




/****************************************************************************/
/*	Applet definitions														*/
/*	Applet definitions														*/
/*	Applet definitions														*/
/****************************************************************************/



/*
**	OTG demo applet
*/

#include		"class_dr/audio/sing.h"


unsigned long	file_size( int fh );		//	defined in printer.c

unsigned char	OTG_grab_far_end_device( void );
void			OTG_release_far_end_device( void );
unsigned char	OTG_command_to_device( unsigned char *bf_ptr, unsigned char direction, unsigned char command, unsigned char sub_command, unsigned short size, unsigned short *done_size_ptr, unsigned char timeout_sec );




unsigned short otg_demo_wasabi_init_commands( device_instance *dvi_ptr )
{
	if ( devep_regist_config_descriptors( dvi_ptr, 1, 1 ) )
	{
		mprintf( RED, CONTINUE, "error : storage_init_commands\r\n" );
		return ( error );	//	to dispose device
	}
	
	dvi_ptr->class_instance_ptr	= (void *)0x1;	//	Dummy : To call audio_dispose_process() at device detach

	return ( no_error );
}




//   77777          77777          77777          77777          77777          77777          77777        
//       7              7              7              7              7              7              7         
//      7              7              7              7              7              7              7          
//     7              7              7              7              7              7              7           
//    7              7              7              7              7              7              7            
//    7              7              7              7              7              7              7            

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 

/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Get a string from peripheral"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/

/*
**	OTG demo applet "Get a string from peripheral"
**
**		Host side service
*/


void OTG_demo_host_side_7( void )
{
	char				bf[ 64 ];
	unsigned short		rx_size;
	unsigned short		i;
	
	if ( OTG_grab_far_end_device() )
		return;
	

	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE, CONTINUE, "String message receive\r\n" );

	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_GET_A_STRING, 0, 10, &rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	else
	{
		*(bf + rx_size)	= 0;
		
		mprintf( WHITE, CONTINUE, "   message from remote : " );
		mprintf( (WHITE << 4) | BLACK, CONTINUE, "%s", bf );
		mprintf( WHITE, CONTINUE, "\r\n" );
	}



	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_GET_A_STRING, 1, 64, &rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	else
	{
		*(bf + rx_size)	= 0;
		
		mprintf( WHITE, CONTINUE, "   message from remote : " );
		mprintf( (WHITE << 4) | BLACK, CONTINUE, "%s", bf );
		mprintf( WHITE, CONTINUE, "\r\n" );
	}
	
	OTG_release_far_end_device();
}

//   77777          77777          77777          77777          77777          77777          77777        
//       7              7              7              7              7              7              7         
//      7              7              7              7              7              7              7          
//     7              7              7              7              7              7              7           
//    7              7              7              7              7              7              7            
//    7              7              7              7              7              7              7            

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    

/*
**	OTG demo applet "Get a string from peripheral"
**
**		Peripheral side service
*/

void OTG_demo_peripheral_side_7( char *s, unsigned short *length, unsigned char mode )
{
	mode	&= ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER;

	sprintf( s, "%s%s", mode ? "Hello OTG!   my name is " : "", gp_id_string );
	*length		= strlen( s );
}


//    888            888            888            888            888            888            888          
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//    888            888            888            888            888            888            888          
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//    888            888            888            888            888            888            888          

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 

/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Bar display demo (dummy data transfer)"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/


/*
**	OTG demo applet "Bar display demo (dummy data transfer)"
**
**		Host side service
*/

void OTG_demo_host_side_8( void )
{
	char				bf[ 64 ];
	unsigned short		rx_size;
	unsigned short		i;
	unsigned short		j;
	char				str[ 70 ];
	char				message[]	= "OTG-HOST : data retrieving from remote  ";
//									   1234567890123456789012345678901234567890
	
	if ( OTG_grab_far_end_device() )
		return;

	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE, CONTINUE, "Dummy data transfer\r\n" );

	for ( j = 0; j < 70; j++ )
		*(str + j)	= ' ';

	strncpy( str + 10, message, 40 );

	for ( i = 0; i < 70; i++ )
	{
		unsigned char	t;
		rx_size		= 64;
	
		if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_BAR_DISPLAY, i++, 64, &rx_size, 1 ) )
			break;

		gotoxy( 1, wherey() );

		mprintf( BLACK, CONTINUE, "     " );

		for ( j = 0; j < i; j++ )
			mprintf( BLUE << 4 | WHITE, CONTINUE, "%c", *(str + j) );
			
		for ( j = i; j < 70; j++ )
			mprintf( BLACK << 4 | BLACK, CONTINUE, "%c", *(str + j) );
			
		mprintf( BLACK << 4 | WHITE, CONTINUE, "\r" );
		
		wait_ms( 100L );
	}
	
	mprintf( WHITE, CONTINUE, "\r\nDummy transfer done.\r\n" );

	OTG_release_far_end_device();
}

//    888            888            888            888            888            888            888          
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//    888            888            888            888            888            888            888          
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//    888            888            888            888            888            888            888          

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    

/*
**	OTG demo applet "Bar display demo (dummy data transfer)"
**
**		Peripheral side service
*/

void OTG_demo_peripheral_side_8( unsigned char index )
{
#if 1
	unsigned short		j;
	char				str[ 70 ];
	char				message[]	= "OTG-PERIPHERAL : data sending to remote ";
//									   1234567890123456789012345678901234567890

	index	&= ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER;

	for ( j = 0; j < 70; j++ )
		*(str + j)	= ' ';

	strncpy( str + 10, message, 40 );

	index	= 70 - 1 - index;

	gotoxy( 1, wherey() );

	mprintf( YELLOW, CONTINUE, "     " );

	for ( j = 0; j < index; j++ )
		mprintf( GREEN << 4 | WHITE, CONTINUE, "%c", *(str + j) );
		
	for ( j = index; j < 70; j++ )
		mprintf( BLACK << 4 | BLACK, CONTINUE, "%c", *(str + j) );
		
	mprintf( BLACK << 4 | BLACK, CONTINUE, "\r" );
	
	if ( !index )
		mprintf( BLACK << 4 | BLACK, CONTINUE, "\r\n" );
#endif
}


//    999            999            999            999            999            999            999          
//   9   9          9   9          9   9          9   9          9   9          9   9          9   9         
//   9   9          9   9          9   9          9   9          9   9          9   9          9   9         
//    9999           9999           9999           9999           9999           9999           9999         
//       9              9              9              9              9              9              9         
//    999            999            999            999            999            999            999          

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 

/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Get audio list item and start"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/

/*
**	OTG demo applet "Get audio list item"
**
**		Host side service
*/


#define		OTG_DEMO_SUB_COMMAND_LIST_ITEM		0x00
#define		OTG_DEMO_SUB_COMMAND_AUDIO_START	0x10
#define		OTG_DEMO_SUB_COMMAND_AUDIO_STATE	0x20


void OTG_demo_host_side_9( void )
{
	unsigned char		num_of_items;
	char				bf[ 64 ];
	unsigned short		rx_size;
	unsigned char		key;
	unsigned char		i;

	if ( OTG_grab_far_end_device() )
		return;
				
	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE, CONTINUE, "Play music on remote peer\r\n" );

	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_AUDIO_STATE | 0, 1, &rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	
	if ( ((*bf) & 0xC) != 0xC )		//	"0xC" means playing beep
	{
		if ( !((*bf) & 0x1) )
		{
			mprintf( LIGHTGRAY,  CONTINUE, "\r\n  remote peer " );
			mprintf( LIGHTGREEN, CONTINUE, "%s", g_far_end.id_name );
			mprintf( LIGHTGRAY,  CONTINUE, " have " );
			mprintf( LIGHTRED,   CONTINUE, "no audio device\r\n\r\n" );
			
			OTG_release_far_end_device();
			return;
		}
		else if ( ((*bf) & 0x2) )
		{
			if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_AUDIO_START | 0, 1, &rx_size, 1 ) )
			{
				OTG_release_far_end_device();
				return;
			}
	

			mprintf( LIGHTGRAY,  CONTINUE, "\r\n  remote peer " );
			mprintf( LIGHTGREEN, CONTINUE, "%s", g_far_end.id_name );
			mprintf( LIGHTGRAY,  CONTINUE, " music play " );
			mprintf( LIGHTRED,   CONTINUE, "cancelled\r\n\r\n" );
			
			OTG_release_far_end_device();
			return;
		}
	}



	/*
	 *	Get audio file list on remote
	 */
	 
	mprintf( WHITE,      CONTINUE, "\r\n  remote peer " );
	mprintf( LIGHTGREEN, CONTINUE, "%s", g_far_end.id_name );
	mprintf( WHITE,      CONTINUE, " audio file list.\r\n" );
	 
	for ( i = 0; i < MAX_NUM_OF_AUDIO_FILES; i++ )
	{
		if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_LIST_ITEM | i, 64, &rx_size, 1 ) )
		{
			OTG_release_far_end_device();
			return;
		}
		
		if ( rx_size == 0 )
			break;
			
		*(bf + rx_size)	= 0;
		mprintf( YELLOW, CONTINUE, "      [%d]   ", i );
		mprintf( WHITE,  CONTINUE, "%s\r\n", bf );
	}

	num_of_items	= i;

	for ( ; i < MAX_NUM_OF_AUDIO_FILES; i++ )
		mprintf( BROWN, CONTINUE, "      [%d]\r\n", i );

	do
	{
		mprintf( WHITE, CONTINUE, "    Type a number [0-%u] >> ", num_of_items - 1 );

		key		= ui_key_wait() - '0';

		mprintf( WHITE, CONTINUE, "%c\r\n", key + '0' );
	
		if ( key < num_of_items )
		{
			if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_AUDIO_START | key, 1, &rx_size, 1 ) )
				return;
			else
				break;
		}
	}
	while ( 0 );
	
	mprintf( WHITE, CONTINUE, "Play start command issued to remote\r\n" );

	do
	{
		if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_AUDIO_STATE | 0, 1, &rx_size, 1 ) )
		{
			OTG_release_far_end_device();
			return;
		}
	

		if ( *bf & 0x1 )
			break;
	}
	while ( 1 );
		

	OTG_release_far_end_device();
}

//    999            999            999            999            999            999            999          
//   9   9          9   9          9   9          9   9          9   9          9   9          9   9         
//   9   9          9   9          9   9          9   9          9   9          9   9          9   9         
//    9999           9999           9999           9999           9999           9999           9999         
//       9              9              9              9              9              9              9         
//    999            999            999            999            999            999            999          

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    

/*
**	OTG demo applet "Get audio list item"
**
**		Peripheral side service
*/

unsigned char OTG_demo_peripheral_side_9_0( char *s, unsigned short *length, unsigned char index )
{
	unsigned char	audio_start_flag	= False;	
	
	switch ( index & 0x70 )
	{
		case OTG_DEMO_SUB_COMMAND_LIST_ITEM :
			Dc_printf( WHITE, CONTINUE, "Music file list item #%d (string) returned. by request from remote\r\n", index & 0xF );

			if ( !(*gp_sing_file_strings[ index & 0xF ].file_path_and_name) )
			{
				sprintf( s, "" );
				*length		= 0;
			}
			else
			{
				if ( *(gp_sing_file_strings[ index ].file_comment) != 0 )
					strncpy( s,  gp_sing_file_strings[ index ].file_comment, 63 );
				else
					strncpy( s,  gp_sing_file_strings[ index ].file_path_and_name, 63 );

				*(s + 63)	= 0;
				*length		= strlen( s );
			}
			break;
		case OTG_DEMO_SUB_COMMAND_AUDIO_START :
			*s					= 0;
			*length				= 0x1;
			audio_start_flag	= True;
			break;
		case OTG_DEMO_SUB_COMMAND_AUDIO_STATE :
			*s					= ((is_audio_beep_play() << 3) | (is_audio_active() ? 0x4 : 0x0)| (is_audio_in_play() << 1) | is_audio_exist() );
			*length				= 1;
			break;
		default :
			break;
	}
	
	return ( audio_start_flag );
}


void OTG_demo_peripheral_side_9_11( unsigned char index )
{
	index	&= 0xF;

	audio_main( index );
	mprintf( WHITE, CONTINUE, "Audio play started from remote\r\n" );
}



//    000            000            000            000            000            000            000          
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0            
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//    000            000            000            000            000            000            000          

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 


/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Executable update through OTG"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/

#define		OTG_DEMO_SUB_COMMAND_DATA_REQUEST				0x00
#define		OTG_DEMO_SUB_COMMAND_GET_TRANSFER_STATUS		0x01
#define		OTG_DEMO_SUB_COMMAND_TRANSFER_RESET				0x02
#define		OTG_DEMO_SUB_COMMAND_GET_FILE_MODIFIED_TIME		0x03
#define		OTG_DEMO_SUB_COMMAND_GET_BUILD_INFO				0x04
#define		OTG_DEMO_SUB_COMMAND_GET_SIZE_AND_CHECKSUM		0x05

unsigned long	get_application_file_time( void );
unsigned long	file_modified_time( int fh );



/*
**	OTG demo applet "Executable update through OTG"
**
**		Host side service
*/

void OTG_demo_host_side_0( void )
{
	char				bf[ 64 ];
	unsigned short		rx_size;
	char				status_bf[ 65 ];
	unsigned short		status_rx_size;
	unsigned short		wt_size;
	unsigned long		total_size						= 0;
	
	char				tmp_file_name[]					= "test.exe";
	int					err;
	int					file_handle;
	
	unsigned long		checksum;
	
	unsigned short		i								= 0;
	unsigned char		ci;
	
	char				key;
	
#if 0
	unsigned long		local_file_time					= 0;
	unsigned long		remote_file_time				= 0;
#endif


	if ( OTG_grab_far_end_device() )
		return;
				
	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE,  CONTINUE, "Updating application. Copy from remote... \r\n" );
	
	mprintf( LIGHTGRAY,  CONTINUE, "  remote peer " );
	mprintf( LIGHTGREEN, CONTINUE, "%s", g_far_end.id_name );
	
	mprintf( LIGHTGRAY, CONTINUE, "     >>>" );
	mprintf( LIGHTRED, CONTINUE, "copy" );
	mprintf( LIGHTGRAY, CONTINUE, ">>>" );
	
	mprintf( LIGHTGRAY,  CONTINUE, "     local peer name " );
	mprintf( LIGHTGREEN, CONTINUE, "%s\r\n", gp_id_string );
	
#if 0

	/*
	**	Check remote and local file time
	*/
	
	status_rx_size	= sizeof( unsigned long );
			
	if ( devep_std_request( (unsigned char *)status_bf, dvi_ptr, 0xC003, (OTG_DEMO_APP_UPDATE << 8) | (OTG_DEMO_SUB_COMMAND_GET_FILE_MODIFIED_TIME & 0xFF), 0, &status_rx_size ) )
		;
	
	remote_file_time	= *((unsigned long *)status_bf);
	
	if ( !remote_file_time )
		mprintf( LIGHTRED, CONTINUE, "error for remote side file\r\n" );

	local_file_time		= get_application_file_time();

	mprintf( LIGHTGREEN, CONTINUE, "%lu   %lu   %lu   \r\n", local_file_time, remote_file_time, time( NULL ) );


	if ( local_file_time == remote_file_time )
		mprintf( LIGHTGREEN, CONTINUE, "   These files may be same  %lu - %lu ^ %lu\r\n", local_file_time, remote_file_time, time( NULL ) );
	else if ( local_file_time > remote_file_time )
		mprintf( LIGHTGREEN, CONTINUE, "   Local file may be newer then remote  %lu - %lu\r\n", local_file_time, remote_file_time );
	else
		mprintf( LIGHTGREEN, CONTINUE, "   Remote file may be newer then local  %lu - %lu\r\n", local_file_time, remote_file_time );

	strftime( status_bf, 64, "%d-%b-%Y %H:%M:%S", localtime( &local_file_time ) );
	mprintf( LIGHTGREEN, CONTINUE, "   Local file (%s)     ", status_bf );
	
	strftime( status_bf, 64, "%d-%b-%Y %H:%M:%S", localtime( &remote_file_time ) );
	mprintf( LIGHTGREEN, CONTINUE, "   Remote file (%s)     ", status_bf );
	
#endif
	
	
	
	if ( OTG_command_to_device( status_bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_APP_UPDATE, OTG_DEMO_SUB_COMMAND_GET_BUILD_INFO, 64, &status_rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	
		
	*(status_bf + status_rx_size)	= 0;
			
	mprintf( WHITE,  CONTINUE, "    remote side app version / build time : " );
	mprintf( YELLOW, CONTINUE, "%s\r\n", status_bf );

	mprintf( WHITE,  CONTINUE, "    local  side app version / build time : " );
	mprintf( YELLOW, CONTINUE, "v %s / %s, %s\r\n", VERSION_NUMBER, __DATE__, __TIME__ );


	mprintf( LIGHTGREEN, CONTINUE, "\r\n   press [y] to continue\r\n" );

	if ( 'y' != (ui_key_wait() & 0xFF) )
	{
		OTG_release_far_end_device();

		return;
	}

	mprintf( LIGHTGREEN, CONTINUE, "\r\n" );
	
	
	/*
	**	Open local file
	**
	*/
	
	
	_fmode	= O_BINARY;
	
	if ( 0 != (err	= _dos_creat( tmp_file_name, _A_NORMAL, &file_handle )) )
	{
		mprintf( LIGHTGREEN, CONTINUE, "\r\n    error @ opening print source file \"%s\" in OTG_demo_host_side_0() err=%d\r\n", tmp_file_name, err );
		return;
	}
	
	
	/*
	**	File transfer reset for remote side
	**
	*/
	
	if ( OTG_command_to_device( status_bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_APP_UPDATE, OTG_DEMO_SUB_COMMAND_TRANSFER_RESET, 0, &status_rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	
		
	/*
	**	File transfer process
	**
	*/
	
	checksum	= 0;
	
	do
	{
		if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_APP_UPDATE, OTG_DEMO_SUB_COMMAND_DATA_REQUEST, 64, &rx_size, 3 ) )
		{
			OTG_release_far_end_device();
			return;
		}
	
			
		for	( ci = 0; ci < rx_size; ci++ )
			checksum	+= (unsigned long)*((unsigned char *)bf + ci);
		
		_dos_write( file_handle, bf, rx_size, (unsigned *)(&wt_size) );
		
		total_size	+= rx_size;
		
		if ( !(i++ & 0x3F) )
		{
			status_rx_size	= 64;
			if ( OTG_command_to_device( status_bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_APP_UPDATE, OTG_DEMO_SUB_COMMAND_GET_TRANSFER_STATUS, 64, &status_rx_size, 1 ) )
				return;
			*(status_bf + status_rx_size)	= 0;
			mprintf( WHITE, CONTINUE, "   file transfer state : %s\r", status_bf );
		}
	}
	while ( rx_size == 64 );
	
	status_rx_size	= 64;
	if ( OTG_command_to_device( status_bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_APP_UPDATE, OTG_DEMO_SUB_COMMAND_GET_TRANSFER_STATUS, 64, &status_rx_size, 1 ) )
		return;
	*(status_bf + status_rx_size)	= 0;
	mprintf( WHITE, CONTINUE, "   file transfer state : %s\r", status_bf );
	
	mprintf( WHITE, CONTINUE, "\r\n" );

	_dos_close( file_handle );
	
	
	/*
	**	File transfer done
	**		Confirm update.
	*/
	
	
	if ( OTG_command_to_device( status_bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_APP_UPDATE, OTG_DEMO_SUB_COMMAND_GET_SIZE_AND_CHECKSUM, 8, &status_rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	

	mprintf( WHITE, CONTINUE, "File transfer done, total_size=%lu\r\n", total_size );
	mprintf( WHITE, CONTINUE, "    remote (original)  total_size=%lu, checksum=0x%08lX\r\n", *(((unsigned long *)status_bf) + 0), *(((unsigned long *)status_bf) + 1) );
	mprintf( WHITE, CONTINUE, "    local  (copied)    total_size=%lu, checksum=0x%08lX\r\n", total_size, checksum );
	
	if ( total_size != *(((unsigned long *)status_bf) + 0) )
	{
		mprintf( LIGHTRED, CONTINUE, "   Update aborted : file size different.\r\n" );
		OTG_release_far_end_device();

		return;
	}
	
	if ( checksum != *(((unsigned long *)status_bf) + 1) )
	{
		mprintf( LIGHTRED, CONTINUE, "   Update aborted : checksum different.\r\n" );
		OTG_release_far_end_device();

		return;
	}
	
	while ( True )
	{
		mprintf( LIGHTRED, CONTINUE, "Are you sure to update?  [y] or [n]  >> " );
		
		key		= ui_key_wait() & 0xFF;

		mprintf( WHITE, CONTINUE, "%c\r\n", key );

		if ( key == 'y' )
		{
			remove( gp_app_path_name );
			rename( tmp_file_name, gp_app_path_name );
			mprintf( WHITE, CONTINUE, "Update done, total_size=%lu.\r\n", total_size );
			
			mprintf( WHITE, CONTINUE, "\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n" );
			mprintf( WHITE, CONTINUE, "          " );
			mprintf( (RED << 4) | WHITE, CONTINUE, "       Restart the application. Press any key to quit.      " );
		
			for ( i = 0; i < 7; i++ )
			{
				wait_ms( 150 );
				mprintf( WHITE, CONTINUE, "\r\n" );
			}
			
			ui_key_wait();
			exit( 0 );
		
			break;
		}
		else if ( key == 'n' )
		{
			mprintf( WHITE, CONTINUE, "\r\nUpdate canceled.\r\n" );
			break;
		}
		else
		{
		}
	}
	
	OTG_release_far_end_device();
}

//    000            000            000            000            000            000            000          
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0            
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//    000            000            000            000            000            000            000          

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    


/*
**	OTG demo applet "Executable update through OTG"
**
**		Peripheral side service
*/


void OTG_demo_peripheral_side_0( char *s, unsigned short *length, unsigned char index )
{
	static unsigned char	bf[ 64 ];				//	To keep previous data for retry send
	static unsigned long	total_size		= 0;
	static unsigned long	source_size;
	static unsigned long	checksum		= 0;
	static int				file_handle		= 0;
	static unsigned long	timer;
	unsigned short			rd_size;
//	unsigned short			tx_size;
	unsigned char			i;
	unsigned char			ci;

	if ( index == 1 )
	{
		sprintf( s, "file transfer %7lu / %7lu  (%6.2f%)", total_size, source_size, ((double)total_size / (double)source_size) * 100.00 );
		*length		= strlen( s );
		
		return;
	}
	
	else if ( (index & ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER) == OTG_DEMO_SUB_COMMAND_TRANSFER_RESET )
	{
		if ( file_handle )
			_dos_close( file_handle );
			
		file_handle		= 0;
		total_size		= 0;
		checksum		= 0;
		
		sprintf( s, "file transfer reset" );
		*length		= strlen( s );
		
		return;
	}

	else if ( (index & ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER) == OTG_DEMO_SUB_COMMAND_GET_FILE_MODIFIED_TIME )
	{
		*((unsigned long *)(s))		= get_application_file_time();
		*length		= sizeof( unsigned long );

		return;
	}
	
	else if ( (index & ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER) == OTG_DEMO_SUB_COMMAND_GET_BUILD_INFO )
	{
		sprintf( s, "v %s / %s, %s", VERSION_NUMBER, __DATE__, __TIME__ );
		*length		= strlen( s );

		return;
	}

	else if ( (index & ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER) == OTG_DEMO_SUB_COMMAND_GET_SIZE_AND_CHECKSUM )
	{
		*(((unsigned long *)s) + 0)		= total_size;
		*(((unsigned long *)s) + 1)		= checksum;
		*length		= sizeof( unsigned long ) << 1;

		return;
	}


	else if ( (index & ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER) == 0 )
	{
		if ( 0 == file_handle )
		{
			if ( 0 != _dos_open( gp_app_path_name, O_RDONLY, &file_handle ) )
			{
				mprintf( LIGHTGREEN, CONTINUE, "\r\n    error @ opening print source file \"%s\" in OTG_demo_host_side_0()\r\n", gp_app_path_name );
				*length		= 0;
				return;
			}
			else
			{
				total_size		= 0;
				checksum		= 0;
				source_size		= file_size( file_handle );
				mprintf( WHITE,    CONTINUE, "\r\n\r\nApplication program file transfer requested from remote.\r\n" );			
				mprintf( WHITE,    CONTINUE, "    file :  ", gp_app_path_name );			
				mprintf( LIGHTRED, CONTINUE, "%s\r\n", gp_app_path_name );			
				
				timer	= gp_sof_counter;
			}
		}

		if ( index & OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER )
		{
			mprintf( WHITE, CONTINUE, "    file transfer retry requested       \r\n" );
			
			memcpy( s, bf, 64 );			
			*length		= 64;
		}
		else
		{
			_dos_read( file_handle, bf, 64, (unsigned *)length );

			for	( ci = 0; ci < *length; ci++ )
				checksum	+= (unsigned long)*((unsigned char *)bf + ci);

			memcpy( s, bf, 64 );
			
			total_size	+= *length;

			mprintf( WHITE, CONTINUE, "    file transfer %7lu / %7lu.\r", total_size, source_size );

			if ( *length != 64 )
			{
				_dos_close( file_handle );
				file_handle		= 0;
				
				mprintf( WHITE, CONTINUE, "    file transfer %7lu/%7lu.  checksum=0x%08lX\r", total_size, source_size, checksum );

				mprintf( WHITE, CONTINUE, "\r\n    file transfer done.  %lu ms.\r\n\r\n", gp_sof_counter - timer );
			}
		}
	}
}


unsigned long get_application_file_time( void )
{
	unsigned long	t;
	int				file_handle;

	if ( 0 != _dos_open( gp_app_path_name, O_RDONLY, &file_handle ) )
		t	= 0;
	else
		t	= file_modified_time( file_handle );

	mprintf( LIGHTRED, CONTINUE, "\r\n>>> %lX  %lu\r\n", t,t );

	_dos_close( file_handle );
	
	return ( t );
}


unsigned long file_modified_time( int fh )
{
	struct stat		stat_buffer;
	
	fstat( fh, &stat_buffer );

	return ( (unsigned long)(stat_buffer.st_atime) );
}


//     1              1              1              1              1              1              1           
//    11             11             11             11             11             11             11           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 

/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Clock synchronize"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/

/*
**	OTG demo applet "Syncronize local clock to remote"
**
**		Host side service
*/


void OTG_demo_host_side_1( void )
{
	char				bf[ 64 ];
	unsigned short		rx_size;
	time_t				local_peer_time				= 0;
	time_t				remote_peer_time;
	unsigned long		local_peer_time_stamp;
	unsigned long		remote_offset_ticks;
	unsigned long		timing_for_set_time;
	unsigned short		time_out_adjust__previous_value;
	unsigned char		i;
	int					key;
	unsigned long		display_change0		= 0xFFFFFFFF;
	unsigned long		display_change1		= 0xFFFFFFFF;
		
	
	if ( OTG_grab_far_end_device() )
		return;
	
	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE, CONTINUE, "Set local time to remote time.\r\n" );

	mprintf( WHITE,     CONTINUE, "\r\n" );
	mprintf( WHITE,     CONTINUE, "   Clock synchronization test.\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "   This machine's calendar clock will be synchronized to remote machine\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "   press " );
	mprintf( LIGHTRED,  CONTINUE, "[y]" );
	mprintf( LIGHTGRAY, CONTINUE, " or " );
	mprintf( LIGHTRED,  CONTINUE, "[c]" );
	mprintf( LIGHTGRAY, CONTINUE, " to continue process.\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "   press " );
	mprintf( LIGHTRED,  CONTINUE, "[d]" );
	mprintf( LIGHTGRAY, CONTINUE, " to differ the local clock.\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "   other key to cancel.\r\n\r\n" );



	//
	//	Set remote to generate beep in each 10 seconds
	//
	
	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CLOCK_SYNC, 1, 1, &rx_size, 1 ) )
	{
		mprintf( WHITE, CONTINUE, "    failed to get remote response (timeout).\r\n" );
		OTG_release_far_end_device();
		return;
	}
	

	do
	{
		wait_ms( 0 );		//	This is required for "beep()" (to fill the sing buffer)
	
		if ( local_peer_time	!= time( NULL ) )
		{
			local_peer_time	= time( NULL );
			
			display_change0	= gp_sof_counter + 700;
			display_change1	= gp_sof_counter + 850;
			
			strftime( bf, 64, "%d-%b-%Y %H:%M:%S", localtime( &local_peer_time ) );
			mprintf( LIGHTRED, CONTINUE, "   Current clock %s\r", bf );

			switch ( local_peer_time % 10 )
			{
				case 7 :
				case 8 :
				case 9 :
					beep( 880.00, 0.10, SUSTAIN, MONO );
					break;
				case 0 :
					beep( 1760.00, 2.00, DECAY, MONO );
					break;
				default :
					beep( 220.00, 0.10, SUSTAIN, MONO );
					break;
			}
		}
		else
		{
			if ( display_change0 == gp_sof_counter )
				mprintf( RED, CONTINUE, "   Current clock %s\r", bf );		
			else if ( display_change1 == gp_sof_counter )
				mprintf( BLACK, CONTINUE, "   Current clock %s\r", bf );		
		}
	}
	while ( !(key	= ui_key_in() & 0xFF) );
	
	
	//
	//	Clear remote to generate beep in each 10 seconds
	//
	
	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CLOCK_SYNC, 2, 1, &rx_size, 1 ) )
	{
		mprintf( WHITE, CONTINUE, "    failed to get remote response (timeout).\r\n" );
		OTG_release_far_end_device();
		return;
	}
	
		
	if ( 'd' == key )
	{
		unsigned long	timing_for_set_time;
		time_t			local_peer_time;

		mprintf( LIGHTRED, CONTINUE, "\r\n   Clock differ.\r\n" );

		local_peer_time	= time( NULL );
		
		while ( local_peer_time == time( NULL ) )
			;

		timing_for_set_time		= gp_sof_counter + 500;
		
		while ( gp_sof_counter < timing_for_set_time )
			;
		
		local_peer_time	-= 10;

		stime( &local_peer_time );
		
		mprintf( LIGHTRED, CONTINUE, "   Clock differed.\r\n\r\n" );
		OTG_release_far_end_device();
		return;
	}
	else if ( ('y' != key) && ('c' != key) )
	{
		mprintf( LIGHTRED, CONTINUE, "   Clock sync test canceld by user by key press [%c]\r\n\r\n", key & 0xFF );
		OTG_release_far_end_device();
		return;
	}

	mprintf( LIGHTCYAN, CONTINUE, "   Clock sync test started  wait...  " );

	time_out_adjust__previous_value		= read_register16( Com16_HcATLPTDDoneThresholdTimeOut );
	write_register16( Com16_HcATLPTDDoneThresholdTimeOut, 100 );
	local_peer_time	= time( NULL );
		
	mprintf( LIGHTRED, CONTINUE, "* " );

	while ( local_peer_time == time( NULL ) )
		;
		
	local_peer_time_stamp		= gp_sof_counter;
		
	mprintf( YELLOW, CONTINUE, "* " );

	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CLOCK_SYNC, 0, sizeof( time_t ) + sizeof( unsigned long ), &rx_size, 1 ) )
	{
		mprintf( WHITE, CONTINUE, "    failed to get remote response (timeout).\r\n" );
		OTG_release_far_end_device();
		return;
	}
	
	if ( rx_size != (sizeof( time_t ) + sizeof( unsigned long )) )
	{
		mprintf( WHITE, CONTINUE, "    failed to get remote response (sz=%u)\r\n", rx_size );
		OTG_release_far_end_device();
		write_register16( Com16_HcATLPTDDoneThresholdTimeOut, time_out_adjust__previous_value );

		return;
	}
	
	write_register16( Com16_HcATLPTDDoneThresholdTimeOut, time_out_adjust__previous_value );

	remote_peer_time		= *((time_t *)bf) + 1;
	remote_offset_ticks		= *((time_t *)(bf + sizeof( time_t )));
	
	timing_for_set_time		= local_peer_time_stamp + remote_offset_ticks + 992;
	
	mprintf( LIGHTCYAN, CONTINUE, "* " );

	while ( gp_sof_counter < timing_for_set_time )
		;
	
	stime( &remote_peer_time );

	mprintf( LIGHTGREEN, CONTINUE, "* " );
	
	mprintf( LIGHTCYAN, CONTINUE, "\r\n   done." );
	mprintf( LIGHTGRAY, CONTINUE, " (synchronized to remote_peer_time=%lu  diff. ticks=%lu)\r\n\r\n", remote_peer_time, remote_offset_ticks );

	OTG_release_far_end_device();
}




//     1              1              1              1              1              1              1           
//    11             11             11             11             11             11             11           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    

/*
**	OTG demo applet "Syncronize local clock to remote"
**
**		Peripheral side service
*/

void OTG_demo_peripheral_side_1( char *s, unsigned short *length, unsigned char index )
{
	time_t				local_peer_time;
	unsigned long		local_peer_time_stamp;
	unsigned long		remote_offset_ticks;
	unsigned long		timing_for_set_time;

	if ( index )
	{
		if ( index == 1 )
			gp_beat_flag		= True;
		else
			gp_beat_flag		= False;
		
		*s			= (char)index;
		*length		= 1;

		Dc_printf( WHITE, CONTINUE, "Local timing beep %s\r\n", gp_beat_flag ? "enabled" : "disabled" );
		return;
	}
			

	local_peer_time_stamp	= isr_get_frame_number();
	local_peer_time			= time( NULL );
	
	mprintf( WHITE, CONTINUE, "  Clock synchronizing from remote peer.\r\n" );

	while ( local_peer_time == time( NULL ) )
		;

	remote_offset_ticks	= isr_get_frame_number() - local_peer_time_stamp;
	mprintf( WHITE, CONTINUE, "  Reference timing generated  %lu.\r\n", remote_offset_ticks );
	
	*((time_t *)s)							= time( NULL );
	*((time_t *)(s + sizeof( time_t )))		= remote_offset_ticks;
	*length									= sizeof( time_t ) + sizeof( unsigned long );

	Dc_printf( WHITE, CONTINUE, "Sending time info 0x%08lX  0x%08lX\r\n", *((time_t *)s), *((time_t *)(s + sizeof( time_t ))) );
}



//    222            222            222            222            222            222            222          
//   2   2          2   2          2   2          2   2          2   2          2   2          2   2         
//      2              2              2              2              2              2              2          
//     2              2              2              2              2              2              2          
//    2              2              2              2              2              2              2          
//   22222          22222          22222          22222          22222          22222          22222         

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 

/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Music play with OTG remote source"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/
  
 /*
**	OTG demo applet "Music play with OTG remote source"
**
**		Host side service
*/

#define		OTG_DEMO_SUB_COMMAND_REMOTE_F_OPEN		0x10
#define		OTG_DEMO_SUB_COMMAND_REMOTE_F_READ		0x20
#define		OTG_DEMO_SUB_COMMAND_REMOTE_F_CLOSE		0x30
#define		OTG_DEMO_SUB_COMMAND_N_OF_FILES			0x40

#define		TRANSFER_SIZE		1792	//	== 0x700 ...((((int)1764 / (int)64) + 1) * 64 )

unsigned char	g_rfp_tmp_buff[ 2048 ];

unsigned char	g_data_tr_done;
void			test_data_tr( endpoint_info_ptr dummy );
unsigned short	file_read_from_remote( short *data_buffer );
void			remote_read_callback( endpoint_info_ptr dummy );
void			play_remote_file( unsigned short (*buff_fill_func)( short *buffer_ptr ) );
void			remote_stop( void );



unsigned char OTG_demo_host_side_2( unsigned char selection )
{
	char				bf[ 64 ];
	unsigned char		*data_buffer;
	unsigned short		rx_size;
	unsigned short		i;
	unsigned char		selection_limit;
	unsigned char		tr_index;
	unsigned long		p_sec;
	int					key;


	/*
	 *	Grab remote peer
	 */
	 
	if ( OTG_grab_far_end_device() )
		return ( 0 );
	
	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE, CONTINUE, "Play music on local peer, data from remote.\r\n" );

	OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_REMOTE_BEEP, 0, 4, &rx_size, 1 );
	
	beep( 440.00, 1.0, DECAY, POLY );


	/*
	 *	Set remote to bulk transfer enabled interface
	 */
	 
//	tx_size		= 0;
//	devep_std_request( bf, g_far_end.target_device_instance_ptr, std_Dv_request_SET_INTERFACE, 1, 0, &tx_size );


	wait_ms( 100 );

	if ( selection == OTG_AUDIO_GET_N_OF_FILE )
	{	
		OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_REMOTE_AUDIO, OTG_DEMO_SUB_COMMAND_N_OF_FILES, 1, &rx_size, 1 );
		
//		OTG_release_far_end_device();
		return ( *((unsigned char *)bf) );
	}
	
	

	/*
	 *	Get audio file list on remote
	 */
	
	if ( selection != OTG_AUDIO_MANUAL_SELECTION )
	{
		key		= selection;
	}
	else
	{
		mprintf( WHITE,      CONTINUE, "\r\n  remote peer " );
		mprintf( LIGHTGREEN, CONTINUE, "%s", g_far_end.id_name );
		mprintf( WHITE,      CONTINUE, " audio file list.\r\n" );
		 
		
		for ( i = 0; i < MAX_NUM_OF_AUDIO_FILES; i++ )
		{
			if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_LIST_ITEM | i, 64, &rx_size, 1 ) )
			{
				OTG_release_far_end_device();
				return ( 0 );
			}
		
			if ( rx_size == 0 )
				break;
				
			*(bf + rx_size)	= 0;
			mprintf( LIGHTCYAN, CONTINUE, "      [%d]   ", i );
			mprintf( WHITE, CONTINUE, "%s\r\n", bf );
		}

		selection_limit		= i;

		for ( ; i < MAX_NUM_OF_AUDIO_FILES; i++ )
			mprintf( CYAN, CONTINUE, "      [%d]   \r\n", i );

		/*
		 *	Select a file to play on local
		 */
		 
		mprintf( WHITE, CONTINUE, "    Type a number [0-%u] >> ", selection_limit - 1 );


		key		= ui_key_wait() - '0';

		mprintf( WHITE, CONTINUE, "%c\r\n", key + '0' );

		if ( !((key & 0xFF) < selection_limit) )
		{
			mprintf( LIGHTRED, CONTINUE, "\r\n    File selection error. Selected number is invalid.\r\n\r\n" );

			OTG_release_far_end_device();
			return ( 0 );
		}
		 
		key		&= 0xF;
	}

	while ( is_audio_active() )		//	wait for beep process completion
		wait_ms( 50 );

	wait_ms( 200 );


	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_CTRL_AUDIO, OTG_DEMO_SUB_COMMAND_LIST_ITEM | key, 64, &rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return ( 0 );
	}
	*(bf + rx_size)	= 0;
	mprintf( WHITE, CONTINUE, "\r\n\r\n    Play start : " );
	mprintf( LIGHTCYAN, CONTINUE, "%s\r\n", bf );



	/*
	 *	Open file and setup remote to send data
	 */
	 
	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_REMOTE_AUDIO, OTG_DEMO_SUB_COMMAND_REMOTE_F_OPEN | key, 4, &rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return ( 0 );
	}
	
	
	
	if ( !(*((unsigned long *)bf)) )
	{
		mprintf( LIGHTRED, CONTINUE, "\r\n    Failed to open audio file on remote peer.\r\n\r\n" );
		OTG_release_far_end_device();
		return ( 0 );
	}
	
	p_sec		= bytes_to_sec( *((unsigned long *)bf) );

	mprintf( WHITE,     CONTINUE, "\r\n    Playing music from remote data source...\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "    total data size = %lu (%4.1lfM) bytes.\r\n", *(unsigned long *)bf, (double)(*(unsigned long *)bf) / (double)(1UL << 20) );
	mprintf( LIGHTGRAY, CONTINUE, "    total play time = %lu secs ( %lu min %lu sec ).\r\n", p_sec, p_sec / 60, p_sec % 60  );
	mprintf( LIGHTGRAY, CONTINUE, "    press " );
	mprintf( LIGHTRED,  CONTINUE, "[a]" );
	mprintf( LIGHTGRAY, CONTINUE, " to abort playing. \r\n\r\n" );

	/*
	 *	Play start
	 */
 
	play_remote_file( file_read_from_remote );
	
	return ( 0 );
}


unsigned char			g_rfp_tr_index;
unsigned short			g_rfp_remaining_tr_size;
unsigned short			g_rfp_transferred_size;
unsigned char			g_rfp_transfer_stop;
transfer_instance		*g_rfp_tip;
unsigned char			*g_rfp_bf_ptr;


unsigned short file_read_from_remote( short	*data_buffer )
{
	unsigned char		dummy_buffer;
	unsigned short		size;
	unsigned long		timeout;

	/*
	 *	Vender specific command : to let remote read file data and set the bulk transfer
	 */

	g_rfp_bf_ptr				= g_rfp_tmp_buff;
	g_rfp_transferred_size		= 0;
	g_rfp_remaining_tr_size		= TRANSFER_SIZE;
	g_rfp_transfer_stop			= False;

	/*	
	 *	Prepare bulk transfer
	 */
	
	g_data_tr_done		= False;


	if ( g_rfp_tr_index == 0xFF )
		if ( (NO_OPEN_ATL_TRANSFER_SLOT == (g_rfp_tr_index	= atlmix_get_open_transfer_index( BULK_TRANSFER ))) )
			mprintf( LIGHTRED, ABORT, "error @ opening bulk_transfer, transfer list full.\r\n" );
	
	/*	
	 *	Start bulk transfer
	 */
		
	g_rfp_tip		= atlmix_set_transfer( BULK_TRANSFER, 0, g_rfp_tr_index, g_rfp_bf_ptr, g_rfp_remaining_tr_size, IN, (g_far_end.target_device_instance_ptr)->epi_ptr[ EpIN ][ 4 ], remote_read_callback );
	
	
	/*
	 *	Wait for bulk transfer done
	 *		This loop blocks the execution of non-ISR process.
	 */
	 
	timeout			= gp_sof_counter + 300;
	
	while ( !g_data_tr_done && (gp_sof_counter < timeout) )
		;

	g_rfp_transfer_stop		= True;

	
	/*
	 *	Post process for bulk transfer
	 */
	
	if ( !g_data_tr_done )	//	This is timeout
		g_rfp_transferred_size	= TRANSFER_SIZE;		//	Set fake read size
		
	/*
	 *	Copy data to buffer
	 */
	 
	size	= g_rfp_transferred_size > (MEMORY_FILLING_SIZE_FROM_FILE << 1) ? (MEMORY_FILLING_SIZE_FROM_FILE << 1) : g_rfp_transferred_size;
	
	memcpy( (unsigned char *)data_buffer, g_rfp_tmp_buff, size );

	/*
	 *	Return read data size
	 */
	 
	return ( size >> 1 );	//	size convert from bytes to short
}


void remote_read_callback( endpoint_info_ptr dummy )
{
	/*
	 *	This is a call back function for bulk transfer
	 */
	 
	transfer_instance	*tip;
	unsigned short		size;
	
	dummy	= dummy;
	
	size		= g_rfp_tip->transferred_size;
	
	g_rfp_bf_ptr			+= size;
	g_rfp_transferred_size	+= size;
	g_rfp_remaining_tr_size -= size;
	
	if ( g_rfp_remaining_tr_size == 0 )
		g_data_tr_done	= 0xF;	
	else if ( (g_rfp_tip->completion_code) )
		g_data_tr_done	= g_rfp_tip->completion_code;
	else if ( !g_rfp_transfer_stop )												//	Retry for remaining data
		atlmix_set_transfer( BULK_TRANSFER, 0, g_rfp_tr_index, g_rfp_bf_ptr, g_rfp_remaining_tr_size, IN, (g_far_end.target_device_instance_ptr)->epi_ptr[ EpIN ][ 4 ], remote_read_callback );
}


void play_remote_file( unsigned short (*buff_fill_func)( short *buffer_ptr ) )
{
	device_instance		*dvi_ptr;

	if ( is_audio_active() )
		return;

	if ( NULL == (dvi_ptr		= devep_find_class_interface( AUDIO_CLASS_INTERFACE, 0 )) )
		return ;

	
	g_rfp_tr_index		= 0xFF;
	
	if ( 0 != audio_initialize( dvi_ptr, "*", buff_fill_func, remote_stop ) )
		return;

	audio_start();
}


void remote_stop( void )
{
	char				bf[ 64 ];
	unsigned short		rx_size;
	
	atlmix_free_transfer_index( BULK_TRANSFER, g_rfp_tr_index );
	g_rfp_tr_index		= 0xFF;
	
	
	mprintf( WHITE, CONTINUE, "    remote file play end.        \r\n" );

	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_REMOTE_AUDIO, OTG_DEMO_SUB_COMMAND_REMOTE_F_CLOSE, 4, &rx_size, 1 ) )
	{
		OTG_release_far_end_device();
		return;
	}
	
	mprintf( WHITE, CONTINUE, "    remote file closed.\r\n" );

	OTG_release_far_end_device();
}




//    222            222            222            222            222            222            222          
//   2   2          2   2          2   2          2   2          2   2          2   2          2   2         
//      2              2              2              2              2              2              2          
//     2              2              2              2              2              2              2          
//    2              2              2              2              2              2              2          
//   22222          22222          22222          22222          22222          22222          22222         

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    

/*
**	OTG demo applet "Music play with OTG remote source"
**
**		Peripheral side service
*/

#define			NUM_OF_BUFF		2


typedef	struct		_peri_bf	{
									unsigned char	bp[ TRANSFER_SIZE ];
									unsigned short	length;
								}
								peri_bf;

peri_bf			g_pbf[ 2 ];
unsigned char	g_pbf_switch;
int				g_rfp_file_handle		= 0;
unsigned char	*g_transmitting_buffer_pos_ptr;
unsigned short	g_transmitting_length;
unsigned long	g_file_size_bytes;
unsigned long	g_total_transferred_bytes;
unsigned long	g_last_access_time_stanp;
unsigned long	g_remote_file_read_request;

void			file_acccess_monitor( void );

char			fmt[]			= " %10lu bytes data transferred.  (ramaining %03lu sec)   \r";
unsigned long	fmt_length		= 60L;
unsigned long	pos_calc_factor;

unsigned char	g_Dc_display_rating;
unsigned char	g_Dc_display_rating_mask	= 0x0F;

#define			SCALE_pos_calc_factor		26


void OTG_demo_peripheral_side_2( char *s, unsigned short *length, unsigned char index )
{
	switch ( index & 0x70 )
	{
		case OTG_DEMO_SUB_COMMAND_REMOTE_F_OPEN :
		
			if ( g_rfp_file_handle )
				_dos_close( g_rfp_file_handle );
		
			mprintf( WHITE,      CONTINUE, " \r\n" );
			mprintf( WHITE,      CONTINUE, " \r\n" );
			mprintf( WHITE,      CONTINUE, " \r\n" );
			mprintf( WHITE,      CONTINUE, " \r\n" );
			mprintf( LIGHTGREEN, CONTINUE, "  audio file open \"%s\" \r\n", gp_sing_file_strings[ index & 0xF ].file_path_and_name );
		
			Dc_printf( WHITE, CONTINUE, "remote command : File \"#%u\" open and start serving data.\r\n", index & 0xF );

			if ( 0 != (_dos_open( gp_sing_file_strings[ index & 0xF ].file_path_and_name, O_RDONLY, &g_rfp_file_handle )) )
			{
				*((unsigned long *)s)		= 0x0;
				*length						= 0x4;
				
				mprintf( LIGHTGREEN, CONTINUE, "  audio file open failed. \r\n" );
			}
			else
			{
				wave_header		wave_head;
				unsigned int	readsz;

				g_total_transferred_bytes	= 0;
				g_pbf_switch				= 0;
				
				g_file_size_bytes			= file_size( g_rfp_file_handle );
				*((unsigned long *)s)		= g_file_size_bytes;
				*length						= 0x4;
				
				pos_calc_factor				= (fmt_length << SCALE_pos_calc_factor) / g_file_size_bytes;
				g_Dc_display_rating			= 0;
				
				//	Skip WAVE header part
				_dos_read( g_rfp_file_handle, &wave_head, sizeof( wave_header ), &readsz );
				
				if ( 0 != (_dos_read( g_rfp_file_handle, g_pbf[ g_pbf_switch ].bp, (MEMORY_FILLING_SIZE_FROM_FILE << 1), (unsigned *)(&(g_pbf[ g_pbf_switch ].length)) )) )
					mprintf( LIGHTGREEN, CONTINUE, "  audio file read failed. \r\n" );
	
				mprintf( LIGHTGREEN, CONTINUE, "  audio file opened to serve %s (%lu bytes)\r\n", gp_sing_file_strings[ index & 0xF ].file_path_and_name, g_file_size_bytes );
				mprintf( WHITE,      CONTINUE, "\r\n" );
				mprintf( WHITE,      CONTINUE, "    " );
				mprintf( (RED << 4) | WHITE, CONTINUE, " DC serving audio data to HOST peer. " );
				mprintf( WHITE,      CONTINUE, "\r\n" );
				
				if ( *(gp_sing_file_strings[ index & 0xF ].file_comment) )
					mprintf( WHITE,      CONTINUE, "    \"%s\"\r\n", gp_sing_file_strings[ index & 0xF ].file_comment );
				else
					mprintf( WHITE,      CONTINUE, "    \"%s\"\r\n", gp_sing_file_strings[ index & 0xF ].file_path_and_name );
				
				mprintf( WHITE, CONTINUE, "\r\n\r\n\r\n" );
	
				g_remote_file_read_request		= 1;

				g_last_access_time_stanp		= gp_sof_counter;
				gene_install_asynchronous_periodic_process( 7, file_acccess_monitor );
			}
			break;
			

//		case OTG_DEMO_SUB_COMMAND_REMOTE_F_READ :
//			break;
			
		case OTG_DEMO_SUB_COMMAND_REMOTE_F_CLOSE :

			gene_install_asynchronous_periodic_process( 7, NULL );
			
			Dc_printf( WHITE, CONTINUE, "remote command : File close (%lu bytes data transferred)\r\n", g_total_transferred_bytes );

			if ( g_rfp_file_handle )
			{
				_dos_close( g_rfp_file_handle );
				g_rfp_file_handle	= 0;
				
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( LIGHTGREEN, CONTINUE, "  audio file closed. Play finished.\r\n  %10lu (%5.2lfM) bytes data transferred.\r\n", g_total_transferred_bytes, (double)g_total_transferred_bytes / (double)(1L << 20) );
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( WHITE,      CONTINUE, " \r\n" );
				mprintf( WHITE,      CONTINUE, " \r\n" );

				*((unsigned long *)s)		= 0xCCCCDDDD;		//	return dummy data
				*length						= 0x4;
			}
			
			break;

		case OTG_DEMO_SUB_COMMAND_N_OF_FILES :

			{
				unsigned char	i;
				
				for ( i = 0; i < MAX_NUM_OF_AUDIO_FILES; i++ )
					if ( !(*gp_sing_file_strings[ i ].file_path_and_name) )
						break;
				
				*((unsigned char *)s)	= i;
				*length					= 0x1;
			}
			
			break;
		default :
			break;
	}
}


void otg_demo_file_read_periph_side( void )
{
	char			s[ 70 ];
	char			pos_char;
	unsigned char	pos;
	unsigned short	i;
	unsigned char	progress_bar_character;
	unsigned char	progress_bar_background;
	unsigned char	progress_bar_done_character;
	unsigned char	progress_bar_done_background;

	if ( !(g_Dc_display_rating++ & g_Dc_display_rating_mask) )
	{
		if ( gp_is_in_DOS_environment )
		{
			progress_bar_done_character			=  BLACK;
			progress_bar_done_background		= (LIGHTGRAY  << 4);
			progress_bar_character				=  LIGHTGREEN;
			progress_bar_background				= (CYAN       << 4);
		}
		else
		{
			progress_bar_done_character			=  GREEN;
			progress_bar_done_background		= (WHITE      << 4);
			progress_bar_character				=  BLACK;
			progress_bar_background				= (LIGHTGREEN << 4);
		}


		sprintf( s, fmt, g_total_transferred_bytes, bytes_to_sec(g_file_size_bytes - g_total_transferred_bytes) );

		pos			= (pos_calc_factor * g_total_transferred_bytes) >> SCALE_pos_calc_factor;
		pos_char	= *(s + pos);
		*(s + pos)	= 0;

		Dc_printf( progress_bar_done_background | progress_bar_done_character, CONTINUE, "%s", s );
		
		*(s + pos)	= pos_char;
		Dc_printf( progress_bar_background      | progress_bar_character,      CONTINUE, "%s", s + pos );
	}
	
	
	if ( 0 != (_dos_read( g_rfp_file_handle, g_pbf[ g_pbf_switch ].bp, (MEMORY_FILLING_SIZE_FROM_FILE << 1), (unsigned *)(&(g_pbf[ g_pbf_switch ].length)) )) )
		mprintf( LIGHTGREEN, CONTINUE, "  audio file read failed. \r\n" );	


	g_total_transferred_bytes		+= g_pbf[ g_pbf_switch ].length;

	g_transmitting_buffer_pos_ptr	=  g_pbf[ g_pbf_switch ].bp;
	g_transmitting_length			= (g_pbf[ g_pbf_switch ].length == (MEMORY_FILLING_SIZE_FROM_FILE << 1)) ? TRANSFER_SIZE : g_pbf[ g_pbf_switch ].length;

//	g_pbf_switch	= g_pbf_switch ? 0 : 1;

	g_last_access_time_stanp		= gp_sof_counter;
}


void file_acccess_monitor( void )
{
	char					dummy0[ 4 ];
	unsigned short			dummy1;


	if ( g_remote_file_read_request )
	{
		g_remote_file_read_request	= 0;
		
		hwacces_isr_hw_disable();

		start_pio_in();

		hwacces_isr_hw_enable();
	}


	if ( gp_sof_counter < (g_last_access_time_stanp + 1000) )
		return;
	
	mprintf( LIGHTRED, CONTINUE, "   WAV file device service detected no access for 1 second.\r\n" );
	OTG_demo_peripheral_side_2( dummy0, &dummy1, OTG_DEMO_SUB_COMMAND_REMOTE_F_CLOSE );					//	close file by device side self
}





//    333            333            333            333            333            333            333          
//   3   3          3   3          3   3          3   3          3   3          3   3          3   3         
//      3              3              3              3              3              3              3          
//       3              3              3              3              3              3              3         
//   3   3          3   3          3   3          3   3          3   3          3   3          3   3         
//    333            333            333            333            333            333            333          

//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      


/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet "Remote beep"
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/

/*
**	OTG demo applet "Remote beep"
**
**		Host side service
*/


void OTG_demo_host_side_3( void )
{
	char				bf[ 64 ];
	unsigned short		rx_size;
	unsigned short		i;
	
	if ( OTG_grab_far_end_device() )
		return;
	

	mprintf( LIGHTCYAN,  CONTINUE, "\r\n\r\nOTG feature demo :   " );
	mprintf( WHITE, CONTINUE, "Beeping together\r\n\r\n" );

	mprintf( WHITE, CONTINUE, "\r\n" );

	OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_REMOTE_BEEP, 0, 4, &rx_size, 1 );
	
	beep( 440.00, 1.00, DECAY, POLY );

	OTG_release_far_end_device();
}

//    333            333            333            333            333            333            333          
//   3   3          3   3          3   3          3   3          3   3          3   3          3   3         
//      3              3              3              3              3              3              3          
//       3              3              3              3              3              3              3         
//   3   3          3   3          3   3          3   3          3   3          3   3          3   3         
//    333            333            333            333            333            333            333          

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    

/*
**	OTG demo applet "Remote beep"
**
**		Peripheral side service
*/

void OTG_demo_peripheral_side_3( char *s, unsigned short *length, unsigned char mode )
{
	mode	&= ~OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER;

	*s			= 0xBEEFBEEF;
	*length		= 4;
	
	beep( 880.00, 1.00, DECAY, POLY );
}


/********* ********** ********** ********** ********** ********** ********** ********** ********** **********
	OTG demo applet UTILITY ROUTINES
 ********* ********** ********** ********** ********** ********** ********** ********** ********** **********/


unsigned long 		g_grab_try			= 0;
unsigned long 		g_grab_succeeded	= 0;

unsigned char OTG_grab_far_end_device( void )
{
	device_instance		*dvi_ptr;
	char				bf[ 11 ];
	unsigned short		rx_size;
	
//mprintf( YELLOW, CONTINUE, "Grab result so far...   succeeded / try  =   %lu / %lu  \r\n", g_grab_succeeded, g_grab_try );
	
	
	g_grab_try++;
	
	g_far_end.previous_bus_request_state	= OTG_bus_request_ON();
	
	if ( False == otg_wait_to_get_mastership() )
	{
		mprintf( LIGHTRED, CONTINUE, "\r\nFailed to get mastership\r\n" );
		OTG_release_far_end_device();

		return ( OTG_ERROR_FAREND_GRAB_FAILD );
	}
	
	dvi_ptr		= portctl_get_OTG_port_device_instance();

	if ( dvi_ptr == NULL )
	{
		mprintf( LIGHTRED, CONTINUE, "\r\nNo OTG device instance on the OTG port.\r\n" );
		OTG_release_far_end_device();
		
		return ( OTG_ERROR_NO_FAREND_DEVICE );
	}
	
	g_far_end.target_device_instance_ptr	= dvi_ptr;
	
	if ( OTG_command_to_device( bf, OTG_CONTROL_TR_DIR_IN, OTG_DEMO_GET_A_STRING, 0, 10, &rx_size, 1 ) )
	{
		return ( OTG_ERROR_FAREND_GRAB_FAILD );
	}
	else
	{
		*(bf + rx_size)	= 0;
		strcpy( g_far_end.id_name, bf );
	}
	
	g_grab_succeeded++;
	
	return ( 0 );
}


void OTG_release_far_end_device( void )
{
	if ( !g_far_end.previous_bus_request_state )
		OTG_bus_request_OFF();
	
	g_far_end.target_device_instance_ptr	= NULL;
}



unsigned char OTG_command_to_device( unsigned char *bf_ptr, unsigned char direction, unsigned char command, unsigned char sub_command, unsigned short size, unsigned short *done_size_ptr, unsigned char timeout_sec )
{
	unsigned short		transfer_size;
	unsigned char		retry_flag;
	unsigned long		timeout;
	
	if ( NULL == g_far_end.target_device_instance_ptr )
	{
		mprintf( LIGHTRED, CONTINUE, "\r\nDid you grabbed OTG device before?\r\n" );
		return ( OTG_CONTROL_TR_ERROR );
	}

	retry_flag			= 0;
	timeout				= gp_sof_counter + ((unsigned long)timeout_sec << 10);
	transfer_size		= size;

	while ( devep_std_request( bf_ptr, g_far_end.target_device_instance_ptr, 0x4003 | (direction << 15), (command << 8) | ((sub_command & 0xFF) | retry_flag), 0, &transfer_size ) )
	{
		if ( gp_sof_counter > timeout )
		{
			mprintf( LIGHTRED, CONTINUE, "    Command to OTG peripheral aborted : timeout.\r\n" );

			return ( OTG_CONTROL_TR_ERROR );
		}

		retry_flag			= OTG_DEMO_SUB_COMMAND_RETRY_TRANSFER;
		transfer_size		= size;
	}
	
	*done_size_ptr		= transfer_size;
	
	return ( OTG_CONTROL_TR_OK );
}




//    000            000            000            000            000            000            000          
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0            
//   0   0          0   0          0   0          0   0          0   0          0   0          0   0         
//    000            000            000            000            000            000            000          
//                 
//     1              1              1              1              1              1              1           
//    11             11             11             11             11             11             11           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//     1              1              1              1              1              1              1           
//                 
//    222            222            222            222            222            222            222          
//   2   2          2   2          2   2          2   2          2   2          2   2          2   2         
//      2              2              2              2              2              2              2          
//     2              2              2              2              2              2              2          
//    2              2              2              2              2              2              2          
//   22222          22222          22222          22222          22222          22222          22222         
//                 
//    333            333            333            333            333            333            333          
//   3   3          3   3          3   3          3   3          3   3          3   3          3   3         
//      3              3              3              3              3              3              3          
//       3              3              3              3              3              3              3         
//   3   3          3   3          3   3          3   3          3   3          3   3          3   3         
//    333            333            333            333            333            333            333          
//                 
//    4              4              4              4              4              4              4            
//    4              4              4              4              4              4              4            
//   4  4           4  4           4  4           4  4           4  4           4  4           4  4         
//   4  4           4  4           4  4           4  4           4  4           4  4           4  4          
//   44444          44444          44444          44444          44444          44444          44444         
//      4              4              4              4              4              4              4          
//                 
//   55555          55555          55555          55555          55555          55555          55555         
//   5              5              5              5              5              5              5             
//   5555           5555           5555           5555           5555           5555           5555          
//       5              5              5              5              5              5              5         
//   5   5          5   5          5   5          5   5          5   5          5   5          5   5         
//    555            555            555            555            555            555            555          
//                 
//    6666           6666           6666           6666           6666           6666           6666         
//   6              6              6              6              6              6              6             
//   6666           6666           6666           6666           6666           6666           6666          
//   6   6          6   6          6   6          6   6          6   6          6   6          6   6         
//   6   6          6   6          6   6          6   6          6   6          6   6          6   6         
//    666            666            666            666            666            666            666          
//                 
//   77777          77777          77777          77777          77777          77777          77777        
//       7              7              7              7              7              7              7         
//      7              7              7              7              7              7              7          
//     7              7              7              7              7              7              7           
//    7              7              7              7              7              7              7            
//    7              7              7              7              7              7              7            
//                 
//    888            888            888            888            888            888            888          
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//    888            888            888            888            888            888            888          
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//   8   8          8   8          8   8          8   8          8   8          8   8          8   8         
//    888            888            888            888            888            888            888          
//                 
//    999            999            999            999            999            999            999          
//   9   9          9   9          9   9          9   9          9   9          9   9          9   9         
//   9   9          9   9          9   9          9   9          9   9          9   9          9   9         
//    9999           9999           9999           9999           9999           9999           9999         
//       9              9              9              9              9              9              9         
//    999            999            999            999            999            999            999          


//   H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT    H   H  OOO   SSSS TTTTT   
//   H   H O   O S       T      H   H O   O S       T      H   H O   O S       T      H   H O   O S       T       
//   HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      HHHHH O   O  SSS    T      
//   H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      H   H O   O     S   T      
//   H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      H   H  OOO  SSSS    T      
 

//   PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    PPPP  EEEE RRRR  I PPPP  H   H    
//   P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    P   P E    R   R I P   P H   H    
//   P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    P   P EEE  R   R I P   P HHHHH    
//   PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    PPP   E    RRRR  I PPPP  H   H    
//   P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    P     EEEE R   R I P     H   H    




