/*
**  WASABI-Hot! version 1.2b   
**
**
**      -- copyright (c) 2001-2003 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 08-Dec-2003                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Portable Systems
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/


/****************************************************************************/
/*	constants																*/
/****************************************************************************/

#define			MAX_NUM_OF_PRINTER_FILES			10
#define			FILE_NAME_STR_LENGTH				100

#define			VENDER_ID_HP						0x03F0
#define			VENDER_ID_EPSON						0x04B8
#define			VENDER_ID_CANON						0x04A9

#define			DEFAULT_FILE_SUFFIX_HP				".pcl"
#define			DEFAULT_FILE_SUFFIX_EPSON			".ecp"
#define			DEFAULT_FILE_SUFFIX_CANON			".bjc"

#define			MAX_PRINTER_DEVICES					2

#define			ACTION_IMMIDIATE					0L
#define			ACTION_START						1L
#define			ACTION_IDLE							0xFFFFFFFF


/****************************************************************************/
/*	types																	*/
/****************************************************************************/

typedef struct  ptr_vid_sfx			{
	                                    unsigned short  vid;
	                                    unsigned char   suffix[5];
	                                }
                                	ptr_vid_suffix;

//
//	printer class parameters for each instances.
//
typedef struct  printer_param	{
									unsigned char			target_device_address;									//	To point the current target printer device address
									unsigned char			*image_buffer_ptr;
									endpoint_info_ptr		endpoint_ptr;
									int						image_file_handle;
									int						tr_index;
									transfer_instance		*tr_instance_ptr;
									unsigned long			file_size;
									unsigned long			transferred_size;
									unsigned short			requested_transfer_size;
									unsigned short			buffer_status;
									unsigned long			time_for_action;
									
									//	Followings are option variables for status monitoring
									
									unsigned char			pi_index;
									char					monitor_string[ 40 ];
									unsigned char			operation_flag;
                                }
                                printer_instance;


/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

extern char			gp_printer_default_file_path[ FILE_NAME_STR_LENGTH ];


/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

void				printer_main( void );
unsigned short		printer_init_commands( device_instance *dvi_ptr );
unsigned short		printer_dispose_process( device_instance *dvi_ptr );
